#version 330 core

// The "Gooch-Shader", adapted from the orange book
//
// GZ, Dec 2013, 2019


//uniform float cool_threshold;
//uniform float warm_threshold;
uniform vec3 Color_cool;
uniform vec3 Color_warm;

in vec3 fNormal;
in vec3 fLightVec;
out vec4 fragColor;

const float Kd = 1.0;               // should really be a uniform


void main()
{
    vec3 N = normalize( fNormal );
    vec3 L = normalize( fLightVec );

    // different variants to compute the interpolation parameter
    // float t = clamp( dot(L, N), 0.0, 1.0 );
    float t = 0.5*( 1.0 + dot(L, N) );
    // float t = smoothstep( cool_threshold, warm_threshold, dot(L, N) );

    vec3 Cgooch = mix( Color_cool, Color_warm, t );             // interpolate the 2 colors
    // for full saturation, move the color onto the surface of the RGB cube
    float m = max( max(Cgooch.r, Cgooch.g), Cgooch.b );
    Cgooch /= m;                                                // makes largest component = 1.0

    vec3 result = Kd * Cgooch;
    fragColor = vec4(result, 1.0);
}


