#version 330 core

// Ein Shader, der sog. "Toon Shading" macht, d.h., die Objekte so
// darstellt, dass sie aehnlich wie in einem Cartoon aussehen (hence the name)
//
// Dieser Shader kommt auch mit positional light sources zurecht, daher
// benoetigt er auch die Position der Fragmente in Weltkoord.
//
// GZ 2011
// PD 2017


uniform mat4 ModelViewProjectionMatrix;
uniform mat4 ModelViewMatrix;
uniform mat4 NormalMatrix;

in vec3 Vertex;

// Wir brauchen spaeter im Fragment-Shader pro Pixel eine Normale;
// dazu benoetigen wir diese 'varying'-Variable;
// dies ist die einzige Aufgabe das Vertex-Shaders
in vec3 Normal;
out vec3 fNormal;

// Wir brauchen spaeter im Fragment-Shader auch die Position des Pixels
// in Weltkoord.; dazu folgende 'varying'-Variable, die im Rasterizer dann
// pro Fragment gesetzt wird
out vec3 surf_pos;

void main()
{
        fNormal = vec4(NormalMatrix * vec4(Normal, 0)).xyz;
        surf_pos = vec4(ModelViewMatrix * vec4(Vertex, 1)).xyz;

        gl_Position = ModelViewProjectionMatrix * vec4(Vertex, 1);
} 
